/* Copyright 1991 Digital Equipment Corporation.               */
/* All rights reserved. See copyright notice in attached file COPYRIGHT. */
/* Last modified on Mon Aug 19 22:33:11 1991 by burrows        */
#include <stdio.h>
#include <strings.h>
#include <errno.h>

extern void perror ();
extern void exit ();
extern long atol ();
extern char *realloc ();

main (argc, argv)
int argc;
char *argv[];
{
	register long *table = 0;
	register long max = 0;
	register long i;
	FILE *fp;
	char buf[4096];
	struct message {
		long group;
		long message;
	} xbuf;
	long newmax;

	if (argc != 2) {
		(void) fprintf (stderr, "usage: precisdelete deletefile\n");
		exit (2);
	}

	if ((fp = fopen (argv[1], "r")) == 0) {
		perror (argv[1]);
		exit (2);
	}

	while (fgets (buf, sizeof (buf), fp) != 0) {
		i = atol (buf);
		if (i < 0) {
			(void) fprintf (stderr,
			    "precisdelete: negative integer in delete file\n");
			exit (2);
		}
		if (i >= max) {
			newmax = i + 1024;
			table = (long *) realloc ((char *) table,
				(unsigned) newmax * sizeof (long));
			if (table == 0) {
				perror ("realloc");
				exit (2);
			}
			bzero ((char *) &table[max],
				(newmax-max) * sizeof (long));
			max = newmax;
		}
		table[i] = -1;
	}

	if (ferror (fp)) {
		perror (argv[1]);
		exit (2);
	}
	(void) fclose (fp);

	i = 0;
	while (fread ((char *) &xbuf, sizeof (xbuf), 1, stdin) == 1) {
		if (i >= max || table[i] == 0)
			(void) fwrite ((char *) &xbuf, sizeof (xbuf),
				1, stdout);
		i++;
	}

	if (ferror (stdin)) {
		perror ("stdin");
		exit (2);
	}

	(void) fflush (stdout);
	if (ferror (stdout) || (fsync (fileno (stdout)) < 0 && errno!=EINVAL)) {
		perror ("stdout");
		exit (2);
	}

	exit (0);
}
